{
	Class Module for Wyvern (C)1999-2000 MinMin.

        "TCommonMemoryStream" from FDELPHI FAQ.
}

unit CopyOwnData;

interface

uses
  Windows, Messages, SysUtils, Classes, wyvMain;

type
{ TCommonMemoryStream class }
  TCommonMemoryStream = class(TStream)
  protected
    FMemory: Pointer;
    FHandle: Integer;
    FSize, FPosition: Longint;
  public
    constructor Create(const Name: string; Size: Longint);
    destructor Destroy; override;
    function Read(var Buffer; Count: Longint):    Longint; override;
    function Write(const Buffer; Count: Longint): Longint; override;
    function Seek(Offset: Longint; Origin: Word): Longint; override;
    procedure SaveToStream(Stream: TStream);
    procedure SaveToFile(const FileName: string);
    property Handle: Integer read FHandle;
    property Memory: Pointer read FMemory;
    property Size: Longint read FSize;
  end;

  TSendData = class(TObject)
  private
    { Private 錾 }
    FComMem: TCommonMemoryStream;
    FStrMem: TMemoryStream;
    FMsgName: string;
    FOwnHnd: hwnd;
    FTargetHandle: hwnd;
  protected
    procedure SetOwnHnd(const Value: hwnd);
  public
    { Public 錾 }
    constructor Create(const Name: string);
    destructor Destroy; override;
    property OwnHnd:  hwnd   read FOwnHnd  write SetOwnHnd;
    property TargetHandle: hwnd read FTargetHandle;
    procedure GetTargetHandle;
    procedure SendOwnMessage;
    procedure SaveComMem(StrList: TStringList);
  end;

var hndCap: string;

//const SIGNATURE_STRING: DWORD = $00000001;

implementation

function EnumWindowsProc(wnd: HWND; lp: LPARAM): Boolean; stdcall;
var strClass,strCaption: string;
begin
    SetLength(strClass, 255);
    GetClassName(wnd,PChar(strClass),255);
    SetLength(strClass, StrLen(PChar(strClass)));
    SetLength(strCaption, 255);
    GetWindowText(wnd,PChar(strCaption),255);
    SetLength(strCaption, StrLen(PChar(strCaption)));
    if (Length(strCaption) > 0) and
       (Copy(strCaption,0,8) = 'Wyvern *') then hndCap := strCaption;
    Result := True;
end;

constructor TCommonMemoryStream.Create(const Name: string; Size: Longint);
begin
    // t@C̃}bvht@C쐬
    FHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE,
                                 0, Size, PChar(Name));
    if FHandle < 0 then
      	raise EFCreateError.Create('L['+Name+']J܂')
    else begin
    FMemory   := MapViewOfFile(FHandle,
       			       FILE_MAP_READ or FILE_MAP_WRITE,
      			       0, 0, 0);
    FSize     := Size;
    FPosition := 0;
    end;
end;

destructor TCommonMemoryStream.Destroy;
begin
    if Handle >= 0 then begin
   	UnmapViewOfFile(FMemory);
     	CloseHandle(Handle);
    end;
end;

function TCommonMemoryStream.Read(var Buffer; Count: Longint): Longint;
begin
    if (FPosition >= 0) and (Count >= 0) then begin
  	Result := FSize - FPosition;
  	if Result > 0 then begin
      	    if Result > Count then Result := Count;
      	    Move(Pointer(Longint(FMemory) + FPosition)^, Buffer, Result);
      	    Inc(FPosition, Result);
      	    Exit;
      	end;
    end;
    Result := 0;
end;

function TCommonMemoryStream.Write(const Buffer; Count: Longint): Longint;
var Pos: Longint;
begin
    if (FPosition >= 0) and (Count >= 0) then begin
  	Pos := FPosition + Count;
  	if Pos > 0 then begin
  	   if Pos > FSize then begin
  	   raise EAccessViolation.Create( 'LE');
  	   end;
  	   System.Move(Buffer, Pointer(Longint(FMemory) + FPosition)^, Count);
  	   FPosition := Pos;
  	   Result := Count;
  	   Exit;
      	end;
    end;
    Result := 0;
end;

function TCommonMemoryStream.Seek(Offset: Longint; Origin: Word): Longint;
begin
    case Origin of
    0: FPosition := Offset;
    1: Inc(FPosition, Offset);
    2: FPosition := FSize + Offset;
    end;
    Result := FPosition;
end;

procedure TCommonMemoryStream.SaveToStream(Stream: TStream);
begin
    if FSize <> 0 then Stream.WriteBuffer(FMemory^, FSize);
end;

procedure TCommonMemoryStream.SaveToFile(const FileName: string);
var Stream: TStream;
begin
    Stream := TFileStream.Create(FileName, fmCreate);
    try
      SaveToStream(Stream);
      finally
      Stream.Free;
    end;
end;

{ TSendData }

constructor TSendData.Create(const Name: string);
begin
     FStrMem  := TMemoryStream.Create;
     FComMem  := nil;
     FMsgName := Name;
end;

destructor TSendData.Destroy;
begin
    if Assigned(FComMem) then FComMem.Free;
    if Assigned(FStrMem) then FStrMem.Free;
  inherited;
end;

procedure TSendData.GetTargetHandle;
begin
    EnumWindows(@EnumWindowsProc,0);
    FTargetHandle := FindWindow(nil, PChar(hndCap));
end;

procedure TSendData.SaveComMem(StrList: TStringList);
begin
    StrList.SaveToStream(FStrMem);
    if FComMem = nil then begin
    FComMem := TCommonMemoryStream.Create(FMsgName, FStrMem.Size);
    FStrMem.SaveToStream(FComMem);
    end;
end;

procedure TSendData.SendOwnMessage;
var hcopy: hwnd;
begin
    hcopy:=FTargetHandle;
    if (hcopy=0) or (hcopy=OwnHnd) then Exit;
    SendMessage(hcopy, WM_MY_COMMEM, WPARAM(FComMem.Size), 0);
end;

procedure TSendData.SetOwnHnd(const Value: hwnd);
begin
    FOwnHnd := Value;
end;

end.
 