{
	Equalizer Module for Wyvern (C)1999-2001 MinMin.
}

unit EqlzCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, MyFunc, mp3plyr;

const
  ValueCount = 10; //Index Value

type
  Pbyte   = ^byte;
  PEqValArry = ^TEqValArry;
  TEqValArry = array[0..ValueCount] of integer;
  PTTArry = ^TTArry;
  TTArry  = array[0..126] of Char;

  TEqualizerControl = class(TObject)
  private
    { Private 錾 }
    FDefaultStr: string;
    FMP3: TMP3Player;
    FEnableEq: Boolean;
    FEqCount: integer;
    FCurrentIdx: integer;
    FChangeFreq: Boolean;
    procedure setEnableEq(const Value: Boolean);
    function LstIndexOf(const chkStr: string): integer;
  public
    { Public 錾 }
    FANamLst: array of string;
    FAValLst: array of TEqValArry;
    function AddArryFromCommaStr(const NamStr, ValStr: string; Idx: integer = -1): boolean;
    function DeleteNameAndValue(const EqIdx: integer): boolean;
    function SwapEqItem(ItemIdx1, ItemIdx2: integer): boolean;
    function MoveEqItem(SrcIdx, DesIdx: integer): boolean;
    procedure ImportEqFile(FileName: string);
    procedure ImportWEQFile(FileName: string);
    procedure ChangeEqFreq(const Freq: string);
    procedure SaveCurrentValue(EqIdx: integer);
    procedure SaveCurrentEachValue(EqIdx, Tag: integer);
    procedure SaveNameAndValue(eqNameStr: string; eqValueArray: PEqValArry);
    procedure SetEqFromList(EqIdx: integer);
    function GetValueStr(EqIdx: integer): string;
    constructor Create(setMP3: TMP3Player; DefaultStr: string; EqCount: integer);
    destructor Destroy;override;
    property EnableEq: Boolean  read FEnableEq write setEnableEq;
    property CurrentIdx: integer read FCurrentIdx write FCurrentIdx;
    property DefaultName: string read FDefaultStr;
    property ChangeFreq: Boolean read FChangeFreq;
  end;

implementation


{ TEqualizerControl }

function TEqualizerControl.AddArryFromCommaStr(const NamStr, ValStr: string;
    Idx: integer = -1): boolean;
var Cnt, SetIdx, tmpValue: integer;
begin
     Result := false;
     if Idx = -1 then begin
       SetLength(FANamLst, Length(FANamLst) + 1);
       SetIdx := High(FANamLst);
       SetLength(FAValLst, Length(FAValLst) + 1);
     end
     else
     if (Idx > -1) and (Idx < Length(FANamLst)) then begin
       SetIdx := Idx;
     end
     else exit;

     FANamLst[SetIdx] := NamStr;
     if ValStr <> '' then
       for Cnt := 0 to FEqCount do  begin
         tmpValue := StrToIntDef(GetDividedString(ValStr, ',', Cnt), 0);
         if Abs(tmpValue) > 100 then tmpValue := 0;
         FAValLst[SetIdx][Cnt] := tmpValue;
       end;
     Result := true;
end;

procedure TEqualizerControl.ChangeEqFreq(const Freq: string);
var Cnt: integer;
begin
    for Cnt := 0 to FEqCount - 1 do
      FMP3.EqualizerFreq[Cnt] := StrToIntDef(GetDividedString(Freq, ',', Cnt), 0);
    FChangeFreq := False;
end;

constructor TEqualizerControl.Create(setMP3: TMP3Player; DefaultStr: string; EqCount: integer);
begin
    FMP3         := setMP3;
    FDefaultStr  := DefaultStr;
    FEqCount     := EqCount;
    FMP3.EqualizerCount := FEqCount;
    FCurrentIdx  := 0;
    FChangeFreq  := True;
    SetLength(FANamLst, 0);
    SetLength(FAValLst, 0);
    Self.AddArryFromCommaStr(FDefaultStr, '0,0,0,0,0,0,0,0,0,0,0');

end;

function TEqualizerControl.DeleteNameAndValue(const EqIdx: integer): Boolean;
var Cnt, Idx: integer;
begin
    Result := false;
    if (EqIdx > High(FANamLst)) or
       (FANamLst[EqIdx] = FDefaultStr) then exit;
    if EqIdx < High(FANamLst) then begin
       for Cnt := EqIdx to High(FANamLst) - 1 do begin
         FANamLst[Cnt] := FANamLst[Cnt + 1];
         for Idx := 0 to ValueCount do
           FAValLst[Cnt][Idx] := FAValLst[Cnt + 1][Idx];
       end;
    end;
    SetLength(FANamLst, Length(FANamLst) - 1);
    SetLength(FAValLst, Length(FAValLst) - 1);
    //FCurrentIdx := 0;
    if FCurrentIdx = EqIdx then FCurrentIdx := 0
    else
    if FCurrentIdx > EqIdx then Dec(FCurrentIdx);

    Result := true;
end;

destructor TEqualizerControl.Destroy;
begin
    FMP3 := nil;
    inherited;
end;

function TEqualizerControl.GetValueStr(EqIdx: integer): string;
var Cnt: integer;
begin
    Result := '';
    for Cnt := 0 to FEqCount - 1 do
      Result := Result + IntToStr(FAValLst[EqIdx][Cnt]) + ',';
    Result := Result + IntToStr(FAValLst[EqIdx][FEqCount]);
end;

procedure TEqualizerControl.ImportEqFile(FileName: string);
const
  hSize = 31;
  dSize = 268;
  tSize = 127;
  ampSize = 63;
var
  M: TMemoryStream;
  pb: Pbyte;
  ptr: PTTArry;
  EValue: TEqValArry;
  Cnt: integer;
  iSize: integer;
  sData: string;
  i: integer;
  j: byte;

begin
  if not FileExistsEx(FileName) then exit;
  M := TMemoryStream.Create;
  try
    M.LoadFromFile(FileName);
    if ((M.Size - hSize) mod dSize) <> 0 then begin
      exit;
    end;
    pb    := M.Memory;
    iSize := (M.Size - hSize) div dSize;
    Inc(pb, hSize);
    Cnt   := 1;
    while (Cnt <= iSize) do begin
      ptr   := PTTArry(pb);
      sData := Trim(String(ptr^));
      Inc(pb, dSize - ValueCount - 1);
      for i := 0 to ValueCount - 1 do begin
        j := pb^;
        EValue[i] := 100 - (200 * j) div ampSize;
        Inc(pb);
      end;
      EValue[ValueCount] := 0;
      Self.SaveNameAndValue(sData, @EValue);
      Inc(pb);
      Inc(Cnt);
    end;
  finally
    M.Free;
  end;
end;

procedure TEqualizerControl.ImportWEQFile(FileName: string);
var
  SL: TStringList;
  Cnt, Idx: integer;
  EValue: TEqValArry;
  EName, ValArryStr: string;
begin
  if not FileExists(FileName) then Exit;
  SL := TStringList.Create;
  try
    SL.LoadFromFile(FileName);
    if SL.Count = 0 then exit;
    for Cnt := 0 to SL.Count - 1 do begin
      EName := Trim(GetDividedString(SL.Strings[Cnt], '=', 0));
      if (EName = '') or ((Length(EName) > 0) and (EName[1] = ';')) then continue;
      ValArryStr := GetDividedString(SL.Strings[Cnt], '=', 1);
      if Trim(ValArryStr) = '' then continue;
      for Idx := 0 to ValueCount do
        EValue[Idx] := StrToIntDef(GetDividedString(ValArryStr, ',', Idx), 0);
      Self.SaveNameAndValue(EName, @EValue);
    end;
  finally
    SL.Free;
  end;
end;

function TEqualizerControl.LstIndexOf(const chkStr: string): integer;
var Cnt: integer;
begin
     Result := -1;
     if Length(FANamLst) = 0 then exit;
     for Cnt := Low(FANamLst) to High(FANamLst) do
       if FANamLst[Cnt] = chkStr then begin
         Result := Cnt; exit;
       end;
end;

function TEqualizerControl.MoveEqItem(SrcIdx, DesIdx: integer): boolean;
var
  tmpVal: string;
  tmpNam: string;
  Cnt, Idx, IdxDiff: integer;
begin
  Result := false;
  if (SrcIdx < 1) or (SrcIdx > High(FANamLst)) or
     (DesIdx < 1) or (DesIdx > High(FANamLst)) then exit;
  tmpVal := GetValueStr(SrcIdx);
  tmpNam := FANamLst[SrcIdx];
  Cnt := SrcIdx;
  if SrcIdx > DesIdx then
    IdxDiff := -1
  else
    IdxDiff := 1;
  while (Cnt <> DesIdx) and
        (Cnt <= High(FANamLst)) and
        (Cnt > 0) do begin
    FANamLst[Cnt] := FANamLst[Cnt + IdxDiff];
    for Idx := 0 to ValueCount do
      FAValLst[Cnt][Idx] := FAValLst[Cnt + IdxDiff][Idx];
    Inc(Cnt, IdxDiff);
  end;
  AddArryFromCommaStr(tmpNam, tmpVal, DesIdx);
  if SrcIdx = FCurrentIdx then
    FCurrentIdx := DesIdx
  else
  if (FCurrentIdx < SrcIdx) and (FCurrentIdx >= DesIdx) then
    Inc(FCurrentIdx)
  else
  if (FCurrentIdx > SrcIdx) and (FCurrentIdx <= DesIdx) then
    Dec(FCurrentIdx);
  Result := true;
end;

procedure TEqualizerControl.SaveCurrentEachValue(EqIdx, Tag: integer);
begin
     if (EqIdx in [0..Length(FANamLst)-1]) and
       (FANamLst[EqIdx] <> FDefaultStr) then begin
       if Tag in [0..FEqCount - 1] then
          FAValLst[EqIdx][Tag] := FMP3.Equalizer[Tag]
       else
          FAValLst[EqIdx][Tag] := FMP3.VolBalance;
    end;
end;

procedure TEqualizerControl.SaveCurrentValue(EqIdx: integer);
var Cnt: integer;
begin
    if (EqIdx >= 0) and (EqIdx <= High(FANamLst)) and
       (FANamLst[EqIdx] <> FDefaultStr) then begin
       for Cnt := 0 to FEqCount - 1 do
         FAValLst[EqIdx][Cnt] := FMP3.Equalizer[Cnt];
       FAValLst[EqIdx][FEqCount] := FMP3.VolBalance;
    end;
end;

procedure TEqualizerControl.SaveNameAndValue(eqNameStr: string;
   eqValueArray: PEqValArry);
var Idx, chkIdx, Cnt: integer;
begin
    chkIdx := LstIndexOf(eqNameStr);
    if chkIdx = -1 then begin
      SetLength(FANamLst, Length(FANamLst) + 1);
      SetLength(FAValLst, Length(FANamLst));
      Idx := High(FANamLst);
    end
    else
      Idx := chkIdx;

    FANamLst[Idx] := eqNameStr;
    for Cnt := 0 to FEqCount - 1 do
      if eqValueArray = nil then
        FAValLst[Idx][Cnt] := FMP3.Equalizer[Cnt]
      else
        FAValLst[Idx][Cnt] := eqValueArray^[Cnt];
    if eqValueArray = nil then
      FAValLst[Idx][FEqCount] := FMP3.VolBalance
    else
      FAValLst[Idx][FEqCount] := eqValueArray^[FEqCount];

    FCurrentIdx := Idx;
end;

procedure TEqualizerControl.setEnableEq(const Value: Boolean);
begin
    FEnableEq             := Value;
    FMP3.EqualizerEnabled := FEnableEq;
end;

procedure TEqualizerControl.SetEqFromList(EqIdx: integer);
var Cnt: integer;
begin
    if (EqIdx < 0) or (EqIdx > High(FANamLst)) then exit;
    FCurrentIdx := EqIdx;
    for Cnt := 0 to FEqCount - 1 do
      FMP3.Equalizer[Cnt] := FAValLst[EqIdx][Cnt];
    FMP3.VolBalance     := FAValLst[EqIdx][FEqCount];
end;

function TEqualizerControl.SwapEqItem(ItemIdx1,
  ItemIdx2: integer): boolean;
var Cnt: integer;
    tmpEqArry: TEqValArry;
    tmpTitle: string;
begin
    Result := false;
    if (ItemIdx1 > High(FANamLst)) or
       (ItemIdx1 < 1) or
       (ItemIdx2 > High(FANamLst)) or
       (ItemIdx2 < 1) then exit;
    for Cnt := 0 to ValueCount do
      tmpEqArry[Cnt] := FAValLst[ItemIdx1][Cnt];
    for Cnt := 0 to ValueCount do
      FAValLst[ItemIdx1][Cnt] := FAValLst[ItemIdx2][Cnt];
    for Cnt := 0 to ValueCount do
      FAValLst[ItemIdx2][Cnt] := tmpEqArry[Cnt];
    tmpTitle := FANamLst[ItemIdx1];
    FANamLst[ItemIdx1] := FANamLst[ItemIdx2];
    FANamLst[ItemIdx2] := tmpTitle;
    if FCurrentIdx = ItemIdx1 then
      FCurrentIdx := ItemIdx2
    else
    if FCurrentIdx = ItemIdx2 then
      FCurrentIdx := ItemIdx1;
    Result := true;
end;

end.
