unit toolbarcustomfrm;
{
  author: Wolfy 2001/02/12
  version: 0.3
  license: BSD

  modified: MinMin  Jul.2001
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ActnList,typinfo,ExtCtrls,inifiles;

type
  TfrmToolbarCustom = class(TForm)
    lvSub: TListView;
    lvMain: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    altbCustom: TActionList;
    actAdd: TAction;
    actRemove: TAction;
    actClose: TAction;
    actReset: TAction;
    actHelp: TAction;
    actUp: TAction;
    actDown: TAction;
    procedure actCloseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actAddUpdate(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actRemoveExecute(Sender: TObject);
    procedure actResetExecute(Sender: TObject);
    procedure actHelpExecute(Sender: TObject);
    procedure actUpExecute(Sender: TObject);
    procedure actDownExecute(Sender: TObject);
    procedure actRemoveUpdate(Sender: TObject);
    procedure actUpUpdate(Sender: TObject);
    procedure actDownUpdate(Sender: TObject);
    procedure lvSubDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lvMainDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lvSubDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lvMainDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure actResetUpdate(Sender: TObject);
  private
    { Private 錾 }
    FToolBar: TToolBar;
    FDummyToolBar: TToolBar;
    FRemoveButtons: TList;
    FIniFilename: String;
    FSubButtons: TList;
    FCurrentName: string;
    procedure AddLV(AToolBar: TToolBar; ASubButtons: TList); overload;
    procedure AddLV(MainList,SubList: TList); overload;
    procedure AdjustButtons(AToolBar: TToolBar; ASubButtons: TList);
    function NotButtonsIncludeSub(Sender: TObject): boolean;
    function IsSeparater(Sender: TObject): boolean;
  public
    { Public 錾 }
    function Execute(CurrentName: string;
        AToolBar: TToolBar;
        ASubButtons: TList;
        IniFilename: String = ''): Boolean;

  end;

implementation

{$R *.DFM}

uses ToolbarManagerEx;

const
  SEPA = 'Separator';

  // TToolButton.Capton gȂRg[ Tag  100Ɂigpj
  _SHOWHINT_TAG = 100;

procedure TfrmToolbarCustom.actCloseExecute(Sender: TObject);
begin     
  Close;
  ModalResult := mrOK;
end;

procedure TfrmToolbarCustom.AddLV(AToolBar: TToolBar; ASubButtons: TList);
var
  i: Integer;
  btn: TToolButton;
begin
  lvMain.Items.BeginUpdate;
  lvSub.Items.BeginUpdate;
  try
    lvMain.Items.Clear;
    lvSub.Items.Clear;

    //؂
    with lvSub.Items.Add do
    begin
      Caption := '؂';
      Data := nil;
      ImageIndex := -1;
    end;

    //C
    for i := 0 to AToolBar.ButtonCount - 1 do
    begin
      btn := AToolBar.Buttons[i];
      with lvMain.Items.Add do
      begin
        //if (btn.Style = tbsDivider) or (btn.Style = tbsSeparator) then
        if IsSeparater(btn) then
        begin
          Caption := '؂';
          ImageIndex := -1;
          Data := nil;
          //폜\
          if FRemoveButtons.IndexOf(btn) = -1 then
            FRemoveButtons.Add(btn);
        end
        else begin
          {if btn.Tag = _SHOWHINT_TAG then begin
            Caption := btn.Hint;
          end
          else
            Caption := btn.Caption;}
          if NotButtonsIncludeSub(btn) then
            Caption := btn.Hint
          else
            Caption := btn.Caption;
          ImageIndex := btn.ImageIndex;
          Data := btn;
        end;
      end;
    end;

    //Tu
    for i := 0 to ASubButtons.Count - 1 do
    begin
      btn := ASubButtons[i];
      //if (btn.Style = tbsDivider) or (btn.Style = tbsSeparator) then
      if IsSeparater(btn) then
      begin
        //폜\
        if FRemoveButtons.IndexOf(btn) = -1 then
          FRemoveButtons.Add(btn);
      end
      else begin
        with lvSub.Items.Add do
        begin
          {if btn.Tag = _SHOWHINT_TAG then
            Caption := btn.Hint
          else
            Caption := btn.Caption;}
          if NotButtonsIncludeSub(btn) then
            Caption := btn.Hint
          else
            Caption := btn.Caption;
          ImageIndex := btn.ImageIndex;
          Data := btn;
        end;
      end;
    end;

  finally
    lvMain.Items.EndUpdate;
    lvSub.Items.EndUpdate;
  end;

end;

procedure TfrmToolbarCustom.AdjustButtons(AToolBar: TToolBar; ASubButtons: TList);
//{^𐮗
var
  i: Integer;
  btn: TToolButton;
begin
  //؂폜
  for i := 0 to FRemoveButtons.Count - 1 do
    try
      TToolButton(FRemoveButtons[i]).Free;
    except
    end;

  with lvMain do
    //for i := 0 to Items.Count - 1 do  //t
    for i := Items.Count - 1 downto 0 do  //
    begin
      if not Assigned(Items[i].Data) then
      begin
        //؂쐬
        btn := TToolButton.Create(FToolBar.Owner);
        btn.Parent := nil;
        btn.Style := tbsSeparator;
        btn.Width := 8;
      end
      else begin
        btn := Items[i].Data;
      end;
      //parentςOvisible
      btn.Visible := True;
      btn.Parent := FDummyToolBar;
      btn.Parent := AToolBar;
    end;

  FSubButtons.Clear;
  with lvSub do
    //for i := 0 to Items.Count - 1 do  //t
    for i := Items.Count - 1 downto 0 do  //
    begin
      if not Assigned(Items[i].Data) then
        Continue;

      btn := Items[i].Data;
      btn.Visible := False;
      btn.Parent := nil;
      //if (btn.Style = tbsDivider) or (btn.Style = tbsSeparator) then
      if IsSeparater(btn) then
        //؂͉
        btn.Free
      else
        FSubButtons.Add(btn);
    end;

end;

function TfrmToolbarCustom.Execute(CurrentName: string;
  AToolBar: TToolBar; ASubButtons: TList;
  IniFilename: String = ''): Boolean;
//s
begin
  Result := False;
  if (not Assigned(AToolBar)) or (not Assigned(ASubButtons)) then
    Exit;

  FToolBar      := AToolBar;
  FSubButtons   := ASubButtons;
  FCurrentName  := CurrentName;

  try
    //
    //imagelist
    lvMain.SmallImages := AToolBar.Images;
    lvSub.SmallImages := AToolBar.Images;
    //listview
    AddLV(AToolBar,ASubButtons);
    //inifile݂邩
    if FileExists(IniFilename) then
    begin
      actReset.Enabled := True;
      FIniFilename := IniFilename;
    end
    else begin
      actReset.Enabled := False;
      FIniFilename := '';
    end;

    Self.ModalResult := mrNone;
    Result := Self.ShowModal = mrOK;
   if Result then
    begin
      AdjustButtons(AToolBar,ASubButtons);
    end;

  finally
    FToolBar := nil;
    FSubButtons := nil;
  end;

end;

procedure TfrmToolbarCustom.FormCreate(Sender: TObject);
//쐬
begin
  FDummyToolBar := TToolBar.Create(Self);
  FDummyToolBar.Enabled := False;
  FDummyToolBar.Visible := False;
  FDummyToolBar.Parent := Self;

  FRemoveButtons := TList.Create;

  FCurrentName := '';
end;

procedure TfrmToolbarCustom.FormDestroy(Sender: TObject);
//j
begin
  FRemoveButtons.Free;
end;  

procedure TfrmToolbarCustom.actAddUpdate(Sender: TObject);
begin
  actAdd.Enabled := Assigned(lvSub.ItemFocused);
end;

procedure TfrmToolbarCustom.actAddExecute(Sender: TObject);
//ǉ
var
  mitem,sitem: TListItem;
  index: Integer;
begin
  sitem := lvSub.ItemFocused;
  if not Assigned(sitem) then
    Exit;

  //}ʒu
  mitem := lvMain.ItemFocused;
  if not Assigned(mitem) then
    index := lvMain.Items.Count
  else
    index := mitem.Index;
  //}
  with lvMain.Items.Insert(index) do
  begin
    if Assigned(sitem.Data) then
    begin
      Assign(sitem);
      sitem.Delete;
    end
    else begin
      //؂
      Assign(sitem);
      Data := nil;
      ImageIndex := -1;        
    end;
  end;
  
end;

procedure TfrmToolbarCustom.actRemoveExecute(Sender: TObject);
//폜
var
  mitem,sitem: TListItem;
  index: Integer;
  btn: TToolButton;
begin
  mitem := lvMain.ItemFocused;
  if not Assigned(mitem) then
    Exit;

  //}ʒu
  sitem := lvSub.ItemFocused;
  if not Assigned(sitem) then
    index := lvSub.Items.Count
  else begin
    index := sitem.Index;
    if index = 0 then
      index := 1;
  end;

  //؂肶ȂȂ
  if Assigned(mitem.Data) then
  begin
    btn := mitem.Data;
    //if (btn.Style = tbsDivider) or (btn.Style = tbsSeparator) then
    if IsSeparater(btn) then
    begin
      //폜\
      if FRemoveButtons.IndexOf(btn) = -1 then
        FRemoveButtons.Add(btn);
    end
    else begin
      //}
      with lvSub.Items.Insert(index) do
      begin
        Assign(mitem);
      end;
    end;
  end;
  //K폜
  mitem.Delete;
end;

procedure TfrmToolbarCustom.actResetExecute(Sender: TObject);
//Ԃɕёւ
var
  i,j,mcount: Integer;
  ini: TMemIniFile;
  btn: TToolButton;
  btnlist,main,sub: TList;
  name,section: String;
begin
  if (not Assigned(FToolBar)) or (not Assigned(FSubButtons)) then
    Exit
  else if not FileExists(FIniFilename) then
    Exit;

  ini := TMemIniFile.Create(FIniFilename);
  btnlist := TList.Create;
  main := TList.Create;
  sub := TList.Create;
  try try

    {if FCurrentIndex > -1 then
      section := (Owner as TToolbarManager).
    else}
    if FCurrentName <> '' then
      section := FCurrentName + '_default'
    else
      section := Owner.Name + '_default';


    //section check
    if not ini.SectionExists(section) then
      Exit;

    //Â̂
    for i := 0 to FToolBar.ButtonCount - 1 do
    begin
      btn := FToolBar.Buttons[i];
      //if (btn.Style = tbsSeparator) or (btn.Style = tbsDivider) then
      if IsSeparater(btn) then
      begin
        btn.Name := '';
        //폜\
        if FRemoveButtons.IndexOf(btn) = -1 then
          FRemoveButtons.Add(btn);
      end
      else
        btnlist.Add(btn);
    end;
    //Tu
    for i := 0 to FSubButtons.Count - 1 do
    begin
      btn := FSubButtons[i];
      //if (btn.Style = tbsSeparator) or (btn.Style = tbsDivider) then
      if IsSeparater(btn) then
      begin
        btn.Name := '';
        //폜\
        if FRemoveButtons.IndexOf(btn) = -1 then
          FRemoveButtons.Add(btn);
      end
      else
        btnlist.Add(btn);
    end;  


    mcount := ini.ReadInteger(section,'maincount',0);
    //C
    for i := 0 to mcount - 1 do
    begin
      name := ini.ReadString(section,'main' + IntToStr(i),'');
      //؂
      if name = SEPA then
      begin
        //
        main.Add(nil);
      end
      else if name <> '' then //T
      begin
        for j := btnlist.Count - 1 downto 0 do
        begin
          btn := btnlist[j];
          if btn.Name = name then //
          begin
            main.Add(btn);
            btnlist.Delete(j);
            Break;
          end;
        end;
      end;
    end;
    //cׂ͂ăTu
    for i := 0 to btnlist.Count - 1 do
      sub.Add(btnlist[i]);
    //lvɓ
    AddLV(main,sub);

    ini.UpdateFile;
  except
  end;
  finally
    sub.Free;
    main.Free;
    btnlist.Free;
    ini.Free;
  end;
end;

procedure TfrmToolbarCustom.actHelpExecute(Sender: TObject);
begin
//
end;

procedure TfrmToolbarCustom.actUpExecute(Sender: TObject);
//ֈړ
var
  mitem,newitem: TListItem;
begin
  mitem := lvMain.ItemFocused;
  if not Assigned(mitem) then
    Exit;

  if mitem.Index > 0 then
  begin
    with lvMain do
    begin
      Items.BeginUpdate;
      try
        newitem := Items.Insert(mitem.index - 1);
        with newitem do
        begin
          Assign(mitem);
          mitem.Delete;
        end;
        ItemFocused := newitem;
      finally
        Items.EndUpdate;
      end;
    end;
  end;

end;

procedure TfrmToolbarCustom.actDownExecute(Sender: TObject);
//ֈړ
var
  mitem,newitem: TListItem;
begin
  mitem := lvMain.ItemFocused;
  if not Assigned(mitem) then
    Exit;

  if mitem.Index < lvMain.Items.Count - 1 then
  begin
    with lvMain do
    begin
      Items.BeginUpdate;
      try
        newitem := Items.Insert(mitem.index + 2);
        with newitem do
        begin
          Assign(mitem);
          mitem.Delete;
        end;
        ItemFocused := newitem;
      finally
        Items.EndUpdate;
      end;
    end;
  end;
end;

procedure TfrmToolbarCustom.actRemoveUpdate(Sender: TObject);
begin
  actRemove.Enabled := Assigned(lvMain.ItemFocused);
end;

procedure TfrmToolbarCustom.actUpUpdate(Sender: TObject);
begin
  actUp.Enabled := Assigned(lvMain.ItemFocused);
end;

procedure TfrmToolbarCustom.actDownUpdate(Sender: TObject);
begin
  actDown.Enabled := Assigned(lvMain.ItemFocused);
end;

procedure TfrmToolbarCustom.lvSubDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var SubTarget: TListItem;
begin
  Accept := False;
  SubTarget := lvSub.GetItemAt(X,Y);
  if (Source = lvMain) or
     ((Source = lvSub) and
      (SubTarget <> nil) and
      (SubTarget <> lvSub.Selected)) then
    Accept := True;
end;

procedure TfrmToolbarCustom.lvMainDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source = lvMain) or (Source = lvSub) then
    Accept := True;
end;

procedure TfrmToolbarCustom.lvSubDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  item,target,newitem: TListItem;
  btn: TToolButton;
begin
  if not (Source is TListView) then
    Exit
  else begin
    item := TListView(Source).Selected;
    if item = nil then
      exit;
    if not Assigned(item.Data) then begin
       if item.ListView = lvMain then
         item.Delete;
      exit;
    end;
  end;

  if Assigned(item.Data) then
  begin
    btn := item.Data;
    //if (btn.Style = tbsDivider) or (btn.Style = tbsSeparator) then
    if IsSeparater(btn) then
    begin
      if FRemoveButtons.IndexOf(btn) = -1 then
        FRemoveButtons.Add(btn);
    end
    else begin
      target := lvSub.GetItemAt(X,Y);
      if not Assigned(target) then
        newitem := lvSub.Items.Add
      else
        newitem := lvSub.Items.Insert(target.Index);

      newitem.Assign(item);
    end;
  end;
  //K폜
    item.Delete;
end;

procedure TfrmToolbarCustom.lvMainDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  item,target,newitem: TListItem;
begin
  if not (Source is TListView) then
    Exit
  else begin
    item := TListView(Source).Selected;
    if not Assigned(item) then
      Exit;
  end;

  target := lvMain.GetItemAt(X,Y);
  if not Assigned(target) then
    newitem := lvMain.Items.Add
  else
    newitem := lvMain.Items.Insert(target.Index);

  newitem.Assign(item);
  if not Assigned(item.Data) then
  begin
    newitem.Data := nil;
    newitem.ImageIndex := -1;
    if item.ListView = lvMain then
      item.Delete; 
  end
  else begin
    //؂肶ȂƂ폜
    item.Delete;
  end;

end;

procedure TfrmToolbarCustom.AddLV(MainList, SubList: TList);
//listviewɕ\
var
  i: Integer;
  btn: TToolButton;
begin
  lvMain.Items.BeginUpdate;
  lvSub.Items.BeginUpdate;
  try
    lvMain.Items.Clear;
    lvSub.Items.Clear;

    //؂
    with lvSub.Items.Add do
    begin
      Caption := '؂';
      Data := nil;
      ImageIndex := -1;
    end;

    for i := 0 to MainList.Count - 1 do
    begin
      with lvMain.Items.Add do
      begin
        btn := MainList[i];

        if (not Assigned(btn)) or
           //((btn.Style = tbsDivider) or (btn.Style = tbsSeparator)) then
           (IsSeparater(btn)) then
        begin
          Data := nil;
          Caption := '؂';
          ImageIndex := -1;
        end
        else begin
          Data := btn;
          if btn.Tag = _SHOWHINT_TAG then
            Caption := btn.Hint
          else
            Caption := btn.Caption;

          //Caption := btn.Caption;
          ImageIndex := btn.ImageIndex;
        end;

      end;
    end;

    for i := 0 to SubList.Count - 1 do
    begin
      btn := SubList[i];
      if (not Assigned(btn)) or
         //((btn.Style = tbsDivider) or (btn.Style = tbsSeparator)) then
         (IsSeparater(btn)) then
      begin
      end
      else begin
        with lvSub.Items.Add do
        begin
          Data := btn;
          Caption := btn.Caption;
          ImageIndex := btn.ImageIndex;
        end;

      end;
    end;

  finally
    lvMain.Items.EndUpdate;
    lvSub.Items.EndUpdate;
  end;

end;


procedure TfrmToolbarCustom.actResetUpdate(Sender: TObject);
begin
  actReset.Enabled := FIniFilename <> '';
end;

function TfrmToolbarCustom.NotButtonsIncludeSub(Sender: TObject): boolean;
begin
  Result := TToolbarManager(Self.Owner).NotButtonsInclude(Sender);
end;

function TfrmToolbarCustom.IsSeparater(Sender: TObject): boolean;
begin
  Result := (not NotButtonsIncludeSub(Sender)) and
            (((Sender as TToolButton).Style = tbsDivider) or
             ((Sender as TToolButton).Style = tbsSeparator));
end;

end.
